// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: Element.proto

package proto.element;

public final class ElementProto {
  private ElementProto() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistryLite registry) {
  }

  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
    registerAllExtensions(
        (com.google.protobuf.ExtensionRegistryLite) registry);
  }
  public interface ElementOrBuilder extends
      // @@protoc_insertion_point(interface_extends:proto.Element)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <code>int64 id = 1;</code>
     */
    long getId();

    /**
     * <code>int64 depth = 2;</code>
     */
    long getDepth();

    /**
     * <code>string name = 3;</code>
     */
    java.lang.String getName();
    /**
     * <code>string name = 3;</code>
     */
    com.google.protobuf.ByteString
        getNameBytes();

    /**
     * <code>repeated string attributes = 4;</code>
     */
    java.util.List<java.lang.String>
        getAttributesList();
    /**
     * <code>repeated string attributes = 4;</code>
     */
    int getAttributesCount();
    /**
     * <code>repeated string attributes = 4;</code>
     */
    java.lang.String getAttributes(int index);
    /**
     * <code>repeated string attributes = 4;</code>
     */
    com.google.protobuf.ByteString
        getAttributesBytes(int index);

    /**
     * <code>repeated .proto.Element children = 5;</code>
     */
    java.util.List<proto.element.ElementProto.Element> 
        getChildrenList();
    /**
     * <code>repeated .proto.Element children = 5;</code>
     */
    proto.element.ElementProto.Element getChildren(int index);
    /**
     * <code>repeated .proto.Element children = 5;</code>
     */
    int getChildrenCount();
    /**
     * <code>repeated .proto.Element children = 5;</code>
     */
    java.util.List<? extends proto.element.ElementProto.ElementOrBuilder> 
        getChildrenOrBuilderList();
    /**
     * <code>repeated .proto.Element children = 5;</code>
     */
    proto.element.ElementProto.ElementOrBuilder getChildrenOrBuilder(
        int index);

    /**
     * <code>.proto.Element parent = 6;</code>
     */
    boolean hasParent();
    /**
     * <code>.proto.Element parent = 6;</code>
     */
    proto.element.ElementProto.Element getParent();
    /**
     * <code>.proto.Element parent = 6;</code>
     */
    proto.element.ElementProto.ElementOrBuilder getParentOrBuilder();
  }
  /**
   * Protobuf type {@code proto.Element}
   */
  public  static final class Element extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:proto.Element)
      ElementOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Element.newBuilder() to construct.
    private Element(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Element() {
      id_ = 0L;
      depth_ = 0L;
      name_ = "";
      attributes_ = com.google.protobuf.LazyStringArrayList.EMPTY;
      children_ = java.util.Collections.emptyList();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return proto.element.ElementProto.internal_static_proto_Element_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return proto.element.ElementProto.internal_static_proto_Element_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              proto.element.ElementProto.Element.class, proto.element.ElementProto.Element.Builder.class);
    }

    private int bitField0_;
    public static final int ID_FIELD_NUMBER = 1;
    private long id_;
    /**
     * <code>int64 id = 1;</code>
     */
    public long getId() {
      return id_;
    }

    public static final int DEPTH_FIELD_NUMBER = 2;
    private long depth_;
    /**
     * <code>int64 depth = 2;</code>
     */
    public long getDepth() {
      return depth_;
    }

    public static final int NAME_FIELD_NUMBER = 3;
    private volatile java.lang.Object name_;
    /**
     * <code>string name = 3;</code>
     */
    public java.lang.String getName() {
      java.lang.Object ref = name_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        name_ = s;
        return s;
      }
    }
    /**
     * <code>string name = 3;</code>
     */
    public com.google.protobuf.ByteString
        getNameBytes() {
      java.lang.Object ref = name_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        name_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int ATTRIBUTES_FIELD_NUMBER = 4;
    private com.google.protobuf.LazyStringList attributes_;
    /**
     * <code>repeated string attributes = 4;</code>
     */
    public com.google.protobuf.ProtocolStringList
        getAttributesList() {
      return attributes_;
    }
    /**
     * <code>repeated string attributes = 4;</code>
     */
    public int getAttributesCount() {
      return attributes_.size();
    }
    /**
     * <code>repeated string attributes = 4;</code>
     */
    public java.lang.String getAttributes(int index) {
      return attributes_.get(index);
    }
    /**
     * <code>repeated string attributes = 4;</code>
     */
    public com.google.protobuf.ByteString
        getAttributesBytes(int index) {
      return attributes_.getByteString(index);
    }

    public static final int CHILDREN_FIELD_NUMBER = 5;
    private java.util.List<proto.element.ElementProto.Element> children_;
    /**
     * <code>repeated .proto.Element children = 5;</code>
     */
    public java.util.List<proto.element.ElementProto.Element> getChildrenList() {
      return children_;
    }
    /**
     * <code>repeated .proto.Element children = 5;</code>
     */
    public java.util.List<? extends proto.element.ElementProto.ElementOrBuilder> 
        getChildrenOrBuilderList() {
      return children_;
    }
    /**
     * <code>repeated .proto.Element children = 5;</code>
     */
    public int getChildrenCount() {
      return children_.size();
    }
    /**
     * <code>repeated .proto.Element children = 5;</code>
     */
    public proto.element.ElementProto.Element getChildren(int index) {
      return children_.get(index);
    }
    /**
     * <code>repeated .proto.Element children = 5;</code>
     */
    public proto.element.ElementProto.ElementOrBuilder getChildrenOrBuilder(
        int index) {
      return children_.get(index);
    }

    public static final int PARENT_FIELD_NUMBER = 6;
    private proto.element.ElementProto.Element parent_;
    /**
     * <code>.proto.Element parent = 6;</code>
     */
    public boolean hasParent() {
      return parent_ != null;
    }
    /**
     * <code>.proto.Element parent = 6;</code>
     */
    public proto.element.ElementProto.Element getParent() {
      return parent_ == null ? proto.element.ElementProto.Element.getDefaultInstance() : parent_;
    }
    /**
     * <code>.proto.Element parent = 6;</code>
     */
    public proto.element.ElementProto.ElementOrBuilder getParentOrBuilder() {
      return getParent();
    }

    public static proto.element.ElementProto.Element parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static proto.element.ElementProto.Element parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static proto.element.ElementProto.Element parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static proto.element.ElementProto.Element parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static proto.element.ElementProto.Element parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static proto.element.ElementProto.Element parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static proto.element.ElementProto.Element parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static proto.element.ElementProto.Element parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static proto.element.ElementProto.Element parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static proto.element.ElementProto.Element parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static proto.element.ElementProto.Element parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static proto.element.ElementProto.Element parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(proto.element.ElementProto.Element prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code proto.Element}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:proto.Element)
        proto.element.ElementProto.ElementOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return proto.element.ElementProto.internal_static_proto_Element_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return proto.element.ElementProto.internal_static_proto_Element_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                proto.element.ElementProto.Element.class, proto.element.ElementProto.Element.Builder.class);
      }

      // Construct using proto.element.ElementProto.Element.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getChildrenFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        id_ = 0L;

        depth_ = 0L;

        name_ = "";

        attributes_ = com.google.protobuf.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000008);
        if (childrenBuilder_ == null) {
          children_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000010);
        } else {
          childrenBuilder_.clear();
        }
        if (parentBuilder_ == null) {
          parent_ = null;
        } else {
          parent_ = null;
          parentBuilder_ = null;
        }
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return proto.element.ElementProto.internal_static_proto_Element_descriptor;
      }

      @java.lang.Override
      public proto.element.ElementProto.Element getDefaultInstanceForType() {
        return proto.element.ElementProto.Element.getDefaultInstance();
      }

      @java.lang.Override
      public proto.element.ElementProto.Element build() {
        proto.element.ElementProto.Element result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public proto.element.ElementProto.Element buildPartial() {
        proto.element.ElementProto.Element result = new proto.element.ElementProto.Element(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        result.id_ = id_;
        result.depth_ = depth_;
        result.name_ = name_;
        if (((bitField0_ & 0x00000008) == 0x00000008)) {
          attributes_ = attributes_.getUnmodifiableView();
          bitField0_ = (bitField0_ & ~0x00000008);
        }
        result.attributes_ = attributes_;
        if (childrenBuilder_ == null) {
          if (((bitField0_ & 0x00000010) == 0x00000010)) {
            children_ = java.util.Collections.unmodifiableList(children_);
            bitField0_ = (bitField0_ & ~0x00000010);
          }
          result.children_ = children_;
        } else {
          result.children_ = childrenBuilder_.build();
        }
        if (parentBuilder_ == null) {
          result.parent_ = parent_;
        } else {
          result.parent_ = parentBuilder_.build();
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return (Builder) super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return (Builder) super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return (Builder) super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return (Builder) super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return (Builder) super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return (Builder) super.addRepeatedField(field, value);
      }
      private int bitField0_;

      private long id_ ;
      /**
       * <code>int64 id = 1;</code>
       */
      public long getId() {
        return id_;
      }
      /**
       * <code>int64 id = 1;</code>
       */
      public Builder setId(long value) {
        
        id_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>int64 id = 1;</code>
       */
      public Builder clearId() {
        
        id_ = 0L;
        onChanged();
        return this;
      }

      private long depth_ ;
      /**
       * <code>int64 depth = 2;</code>
       */
      public long getDepth() {
        return depth_;
      }
      /**
       * <code>int64 depth = 2;</code>
       */
      public Builder setDepth(long value) {
        
        depth_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>int64 depth = 2;</code>
       */
      public Builder clearDepth() {
        
        depth_ = 0L;
        onChanged();
        return this;
      }

      private java.lang.Object name_ = "";
      /**
       * <code>string name = 3;</code>
       */
      public java.lang.String getName() {
        java.lang.Object ref = name_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          name_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>string name = 3;</code>
       */
      public com.google.protobuf.ByteString
          getNameBytes() {
        java.lang.Object ref = name_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          name_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>string name = 3;</code>
       */
      public Builder setName(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        name_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>string name = 3;</code>
       */
      public Builder clearName() {
        
        name_ = getDefaultInstance().getName();
        onChanged();
        return this;
      }
      /**
       * <code>string name = 3;</code>
       */
      public Builder setNameBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        name_ = value;
        onChanged();
        return this;
      }

      private com.google.protobuf.LazyStringList attributes_ = com.google.protobuf.LazyStringArrayList.EMPTY;
      private void ensureAttributesIsMutable() {
        if (!((bitField0_ & 0x00000008) == 0x00000008)) {
          attributes_ = new com.google.protobuf.LazyStringArrayList(attributes_);
          bitField0_ |= 0x00000008;
         }
      }
      /**
       * <code>repeated string attributes = 4;</code>
       */
      public com.google.protobuf.ProtocolStringList
          getAttributesList() {
        return attributes_.getUnmodifiableView();
      }
      /**
       * <code>repeated string attributes = 4;</code>
       */
      public int getAttributesCount() {
        return attributes_.size();
      }
      /**
       * <code>repeated string attributes = 4;</code>
       */
      public java.lang.String getAttributes(int index) {
        return attributes_.get(index);
      }
      /**
       * <code>repeated string attributes = 4;</code>
       */
      public com.google.protobuf.ByteString
          getAttributesBytes(int index) {
        return attributes_.getByteString(index);
      }
      /**
       * <code>repeated string attributes = 4;</code>
       */
      public Builder setAttributes(
          int index, java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAttributesIsMutable();
        attributes_.set(index, value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string attributes = 4;</code>
       */
      public Builder addAttributes(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAttributesIsMutable();
        attributes_.add(value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string attributes = 4;</code>
       */
      public Builder addAllAttributes(
          java.lang.Iterable<java.lang.String> values) {
        ensureAttributesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, attributes_);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string attributes = 4;</code>
       */
      public Builder clearAttributes() {
        attributes_ = com.google.protobuf.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000008);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string attributes = 4;</code>
       */
      public Builder addAttributesBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        ensureAttributesIsMutable();
        attributes_.add(value);
        onChanged();
        return this;
      }

      private java.util.List<proto.element.ElementProto.Element> children_ =
        java.util.Collections.emptyList();
      private void ensureChildrenIsMutable() {
        if (!((bitField0_ & 0x00000010) == 0x00000010)) {
          children_ = new java.util.ArrayList<proto.element.ElementProto.Element>(children_);
          bitField0_ |= 0x00000010;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilderV3<
          proto.element.ElementProto.Element, proto.element.ElementProto.Element.Builder, proto.element.ElementProto.ElementOrBuilder> childrenBuilder_;

      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public java.util.List<proto.element.ElementProto.Element> getChildrenList() {
        if (childrenBuilder_ == null) {
          return java.util.Collections.unmodifiableList(children_);
        } else {
          return childrenBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public int getChildrenCount() {
        if (childrenBuilder_ == null) {
          return children_.size();
        } else {
          return childrenBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public proto.element.ElementProto.Element getChildren(int index) {
        if (childrenBuilder_ == null) {
          return children_.get(index);
        } else {
          return childrenBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public Builder setChildren(
          int index, proto.element.ElementProto.Element value) {
        if (childrenBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureChildrenIsMutable();
          children_.set(index, value);
          onChanged();
        } else {
          childrenBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public Builder setChildren(
          int index, proto.element.ElementProto.Element.Builder builderForValue) {
        if (childrenBuilder_ == null) {
          ensureChildrenIsMutable();
          children_.set(index, builderForValue.build());
          onChanged();
        } else {
          childrenBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public Builder addChildren(proto.element.ElementProto.Element value) {
        if (childrenBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureChildrenIsMutable();
          children_.add(value);
          onChanged();
        } else {
          childrenBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public Builder addChildren(
          int index, proto.element.ElementProto.Element value) {
        if (childrenBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureChildrenIsMutable();
          children_.add(index, value);
          onChanged();
        } else {
          childrenBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public Builder addChildren(
          proto.element.ElementProto.Element.Builder builderForValue) {
        if (childrenBuilder_ == null) {
          ensureChildrenIsMutable();
          children_.add(builderForValue.build());
          onChanged();
        } else {
          childrenBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public Builder addChildren(
          int index, proto.element.ElementProto.Element.Builder builderForValue) {
        if (childrenBuilder_ == null) {
          ensureChildrenIsMutable();
          children_.add(index, builderForValue.build());
          onChanged();
        } else {
          childrenBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public Builder addAllChildren(
          java.lang.Iterable<? extends proto.element.ElementProto.Element> values) {
        if (childrenBuilder_ == null) {
          ensureChildrenIsMutable();
          com.google.protobuf.AbstractMessageLite.Builder.addAll(
              values, children_);
          onChanged();
        } else {
          childrenBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public Builder clearChildren() {
        if (childrenBuilder_ == null) {
          children_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000010);
          onChanged();
        } else {
          childrenBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public Builder removeChildren(int index) {
        if (childrenBuilder_ == null) {
          ensureChildrenIsMutable();
          children_.remove(index);
          onChanged();
        } else {
          childrenBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public proto.element.ElementProto.Element.Builder getChildrenBuilder(
          int index) {
        return getChildrenFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public proto.element.ElementProto.ElementOrBuilder getChildrenOrBuilder(
          int index) {
        if (childrenBuilder_ == null) {
          return children_.get(index);  } else {
          return childrenBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public java.util.List<? extends proto.element.ElementProto.ElementOrBuilder> 
           getChildrenOrBuilderList() {
        if (childrenBuilder_ != null) {
          return childrenBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(children_);
        }
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public proto.element.ElementProto.Element.Builder addChildrenBuilder() {
        return getChildrenFieldBuilder().addBuilder(
            proto.element.ElementProto.Element.getDefaultInstance());
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public proto.element.ElementProto.Element.Builder addChildrenBuilder(
          int index) {
        return getChildrenFieldBuilder().addBuilder(
            index, proto.element.ElementProto.Element.getDefaultInstance());
      }
      /**
       * <code>repeated .proto.Element children = 5;</code>
       */
      public java.util.List<proto.element.ElementProto.Element.Builder> 
           getChildrenBuilderList() {
        return getChildrenFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilderV3<
          proto.element.ElementProto.Element, proto.element.ElementProto.Element.Builder, proto.element.ElementProto.ElementOrBuilder> 
          getChildrenFieldBuilder() {
        if (childrenBuilder_ == null) {
          childrenBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
              proto.element.ElementProto.Element, proto.element.ElementProto.Element.Builder, proto.element.ElementProto.ElementOrBuilder>(
                  children_,
                  ((bitField0_ & 0x00000010) == 0x00000010),
                  getParentForChildren(),
                  isClean());
          children_ = null;
        }
        return childrenBuilder_;
      }

      private proto.element.ElementProto.Element parent_ = null;
      private com.google.protobuf.SingleFieldBuilderV3<
          proto.element.ElementProto.Element, proto.element.ElementProto.Element.Builder, proto.element.ElementProto.ElementOrBuilder> parentBuilder_;
      /**
       * <code>.proto.Element parent = 6;</code>
       */
      public boolean hasParent() {
        return parentBuilder_ != null || parent_ != null;
      }
      /**
       * <code>.proto.Element parent = 6;</code>
       */
      public proto.element.ElementProto.Element getParent() {
        if (parentBuilder_ == null) {
          return parent_ == null ? proto.element.ElementProto.Element.getDefaultInstance() : parent_;
        } else {
          return parentBuilder_.getMessage();
        }
      }
      /**
       * <code>.proto.Element parent = 6;</code>
       */
      public Builder setParent(proto.element.ElementProto.Element value) {
        if (parentBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          parent_ = value;
          onChanged();
        } else {
          parentBuilder_.setMessage(value);
        }

        return this;
      }
      /**
       * <code>.proto.Element parent = 6;</code>
       */
      public Builder setParent(
          proto.element.ElementProto.Element.Builder builderForValue) {
        if (parentBuilder_ == null) {
          parent_ = builderForValue.build();
          onChanged();
        } else {
          parentBuilder_.setMessage(builderForValue.build());
        }

        return this;
      }
      /**
       * <code>.proto.Element parent = 6;</code>
       */
      public Builder mergeParent(proto.element.ElementProto.Element value) {
        if (parentBuilder_ == null) {
          if (parent_ != null) {
            parent_ =
              proto.element.ElementProto.Element.newBuilder(parent_).mergeFrom(value).buildPartial();
          } else {
            parent_ = value;
          }
          onChanged();
        } else {
          parentBuilder_.mergeFrom(value);
        }

        return this;
      }
      /**
       * <code>.proto.Element parent = 6;</code>
       */
      public Builder clearParent() {
        if (parentBuilder_ == null) {
          parent_ = null;
          onChanged();
        } else {
          parent_ = null;
          parentBuilder_ = null;
        }

        return this;
      }
      /**
       * <code>.proto.Element parent = 6;</code>
       */
      public proto.element.ElementProto.Element.Builder getParentBuilder() {
        
        onChanged();
        return getParentFieldBuilder().getBuilder();
      }
      /**
       * <code>.proto.Element parent = 6;</code>
       */
      public proto.element.ElementProto.ElementOrBuilder getParentOrBuilder() {
        if (parentBuilder_ != null) {
          return parentBuilder_.getMessageOrBuilder();
        } else {
          return parent_ == null ?
              proto.element.ElementProto.Element.getDefaultInstance() : parent_;
        }
      }
      /**
       * <code>.proto.Element parent = 6;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          proto.element.ElementProto.Element, proto.element.ElementProto.Element.Builder, proto.element.ElementProto.ElementOrBuilder> 
          getParentFieldBuilder() {
        if (parentBuilder_ == null) {
          parentBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              proto.element.ElementProto.Element, proto.element.ElementProto.Element.Builder, proto.element.ElementProto.ElementOrBuilder>(
                  getParent(),
                  getParentForChildren(),
                  isClean());
          parent_ = null;
        }
        return parentBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFieldsProto3(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:proto.Element)
    }

    // @@protoc_insertion_point(class_scope:proto.Element)
    private static final proto.element.ElementProto.Element DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new proto.element.ElementProto.Element();
    }

    public static proto.element.ElementProto.Element getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<Element>
        PARSER = new com.google.protobuf.AbstractParser<Element>() {
      @java.lang.Override
      public Element parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(
              e.getMessage()).setUnfinishedMessage(
                  builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<Element> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<Element> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public proto.element.ElementProto.Element getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_proto_Element_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_proto_Element_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static  com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\rElement.proto\022\005proto\"\210\001\n\007Element\022\n\n\002id" +
      "\030\001 \001(\003\022\r\n\005depth\030\002 \001(\003\022\014\n\004name\030\003 \001(\t\022\022\n\na" +
      "ttributes\030\004 \003(\t\022 \n\010children\030\005 \003(\0132\016.prot" +
      "o.Element\022\036\n\006parent\030\006 \001(\0132\016.proto.Elemen" +
      "tB\037\n\rproto.elementB\014ElementProtoH\002b\006prot" +
      "o3"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
        new com.google.protobuf.Descriptors.FileDescriptor.    InternalDescriptorAssigner() {
          public com.google.protobuf.ExtensionRegistry assignDescriptors(
              com.google.protobuf.Descriptors.FileDescriptor root) {
            descriptor = root;
            return null;
          }
        };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
    internal_static_proto_Element_descriptor =
      getDescriptor().getMessageTypes().get(0);
    internal_static_proto_Element_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_proto_Element_descriptor,
        new java.lang.String[] { "Id", "Depth", "Name", "Attributes", "Children", "Parent", });
  }

  // @@protoc_insertion_point(outer_class_scope)
}
